#include "ads1292R.h"
#include "mspi.h"
#include "mydelay.h"
#include <stdio.h>

uint8_t ads1292r_data_buff[9] = {0};
uint8_t finish_flag=0;
uint8_t device_id;
uint8_t SPI_BUF[10];

void ADS1292R_Init(void){
      MAP_GPIO_setAsInputPin(ADS1292R_ADC_RDY_PORT, ADS1292R_ADC_RDY_PIN);
      MAP_GPIO_setAsOutputPin(ADS1292R_START_PORT, ADS1292R_START_PIN);
      MAP_GPIO_setAsOutputPin(ADS1292R_PWDN_PORT, ADS1292R_PWDN_PIN);
      MAP_GPIO_setAsOutputPin(ADS1292R_CS_PORT, ADS1292R_CS_PIN);

      GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
      GPIO_setOutputHighOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN);
      GPIO_setOutputLowOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN);
}

uint8_t ADS1292R_SPI_RW(uint8_t data){
    SPI_RW(data);
    return Rx_data;
}

void ADS1292R_PowerOnInit(void){
    //uint8_t device_id ;
    GPIO_setOutputHighOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN);
    GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
    GPIO_setOutputLowOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN);

    GPIO_setOutputHighOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN);
    delay_ms(1000);
    GPIO_setOutputLowOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN);
    delay_us(10);
    GPIO_setOutputHighOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN);
    delay_ms(200);
    GPIO_setOutputLowOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN);
    ADS1292R_CMD(ADS1292R_SDATAC);


    delay_ms(10);

    while(device_id!= 83){
        device_id=ADS1292R_REG(ADS1292R_RREG|ADS1292R_ID, 0x00);
      //  printf("\r ID %d",device_id);
        delay_ms(200);
    }

    printf("\r TOP %d",device_id);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_CONFIG2,0xE0);
    delay_ms(10);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_CONFIG1,0x02);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_LOFF,0xF0);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_CH1SET,0x00);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_CH2SET,0x00);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_RLD_SENS,0x30);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_LOFF_SENS,0x3F);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_RESP1,0xDE);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_RESP2,0x07);
    ADS1292R_REG(ADS1292R_WREG|ADS1292R_GPIO,0x0C);
}

void ADS1292R_Work(void){

    ADS1292R_CMD(ADS1292R_RDATAC);
    GPIO_setOutputHighOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN);

    MAP_GPIO_setAsInputPinWithPullUpResistor(ADS1292R_ADC_RDY_PORT, ADS1292R_ADC_RDY_PIN);
    GPIO_interruptEdgeSelect(ADS1292R_ADC_RDY_PORT,ADS1292R_ADC_RDY_PIN, GPIO_HIGH_TO_LOW_TRANSITION);
    MAP_GPIO_clearInterruptFlag(ADS1292R_ADC_RDY_PORT, ADS1292R_ADC_RDY_PIN);
    MAP_GPIO_enableInterrupt(ADS1292R_ADC_RDY_PORT, ADS1292R_ADC_RDY_PIN);
    MAP_Interrupt_enableInterrupt(INT_PORT4);
}
void ADS1292R_Halt(void){
    ADS1292R_START_L;
    ADS1292R_CMD(ADS1292R_SDATAC);
    MAP_Interrupt_disableInterrupt(INT_PORT4);
}

void ADS1292R_CMD(uint8_t cmd){
    GPIO_setOutputLowOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
    delay_us(10);
    ADS1292R_SPI_RW(cmd);
    delay_us(10);
    GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
}

uint8_t ADS1292R_REG(uint8_t cmd, uint8_t data){
    GPIO_setOutputLowOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
    delay_us(10);
    ADS1292R_SPI_RW(cmd);
    ADS1292R_SPI_RW(0x00);
    if((cmd & 0x20)==0x20){
        ADS1292R_SPI_RW(0x00);
    }else{
        ADS1292R_SPI_RW(data);
    }
    delay_us(10);
    GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
    return Rx_data;
}


void ADS1292R_ReadData(void){

    int i,k;

    GPIO_setOutputLowOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);

    for(k=0;k<50;k++);

    ads1292r_data_buff[k]=SPI_RW(0x00);

    for(i=0;i<9;i++){
       ads1292r_data_buff[i]=SPI_RW(0x00);
    }
    for(k=0;k<50;k++);

    GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN);
}

void PORT4_IRQHandler(void){
    uint32_t status;
    status = MAP_GPIO_getEnabledInterruptStatus(GPIO_PORT_P4);
    MAP_GPIO_clearInterruptFlag(GPIO_PORT_P4, status);
    /* Toggling the output on the LED */
    if(status & GPIO_PIN4){
        //MAP_GPIO_disableInterrupt(ADS1292R_ADC_RDY_PORT, ADS1292R_ADC_RDY_PIN);
              finish_flag=1;
        //MAP_GPIO_toggleOutputOnPin(GPIO_PORT_P1, GPIO_PIN0);
    }
}
