
#ifndef ADS1292R_H_
#define ADS1292R_H_

#include <driverlib/driverlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>

#define ADS1292R_CS_PORT           GPIO_PORT_P5
#define ADS1292R_CS_PIN            GPIO_PIN2

#define ADS1292R_START_PORT        GPIO_PORT_P4
#define ADS1292R_START_PIN         GPIO_PIN2

#define ADS1292R_PWDN_PORT         GPIO_PORT_P4
#define ADS1292R_PWDN_PIN          GPIO_PIN3

#define ADS1292R_ADC_RDY_PORT      GPIO_PORT_P4
#define ADS1292R_ADC_RDY_PIN       GPIO_PIN4

#define ADS1292R_CS_H              GPIO_setOutputHighOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN)
#define ADS1292R_CS_L              GPIO_setOutputLowOnPin(ADS1292R_CS_PORT,ADS1292R_CS_PIN)

#define ADS1292R_PWDN_H            GPIO_setOutputHighOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN)
#define ADS1292R_PWDN_L            GPIO_setOutputLowOnPin(ADS1292R_PWDN_PORT,ADS1292R_PWDN_PIN)

#define ADS1292R_START_H           GPIO_setOutputHighOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN)
#define ADS1292R_START_L           GPIO_setOutputLowOnPin(ADS1292R_START_PORT,ADS1292R_START_PIN)

#define ADS1292R_CLK_PORT          GPIO_PORT_P2
#define ADS1292R_CLK_PIN           GPIO_PIN4

#define ADS1292R_CLK_IN            GPIO_setOutputHighOnPin(ADS1292R_CLK_PORT, ADS1292R_CLK_PIN)



#define ADS1292R_WAKEUP            0x02
#define ADS1292R_STANDBY           0x04
#define ADS1292R_ADSRESET          0x06
#define ADS1292R_START             0x08
#define ADS1292R_STOP              0x0A
#define ADS1292R_OFFSETCAL         0x1A

#define ADS1292R_RDATAC            0x10
#define ADS1292R_SDATAC            0x11
#define ADS1292R_RDATA             0x12

#define ADS1292R_RREG              0x20
#define ADS1292R_WREG              0x40

#define DEVICE_ID_ADS1292R         0x73


#define ADS1292R_ID                0x00
#define ADS1292R_CONFIG1           0x01
#define ADS1292R_CONFIG2           0x02
#define ADS1292R_LOFF              0x03
#define ADS1292R_CH1SET            0x04
#define ADS1292R_CH2SET            0x05
#define ADS1292R_RLD_SENS          0x06
#define ADS1292R_LOFF_SENS         0x07
#define ADS1292R_LOFF_STAT         0x08
#define ADS1292R_RESP1             0x09
#define ADS1292R_RESP2             0x0A
#define ADS1292R_GPIO              0x0B

extern uint8_t finish_flag;

void ADS1292R_Init(void);
void ADS1292R_CMD(uint8_t cmd);
uint8_t ADS1292R_REG(uint8_t cmd, uint8_t data);
void ADS1292R_PowerOnInit(void);

void ADS1292R_Work(void);
void ADS1292R_Halt(void);
void ADS1292R_ReadData(void);
extern uint8_t ads1292r_data_buff[9];



#endif /* ADS1292R_H_ */
